質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.06%

bashでの比較演算子について

解決済

回答 2

投稿

  • 評価
  • クリップ 0
  • VIEW 235

light180

score 147

macOSのバージョンがCatalina以降か、Catalina以前かを判断するbash scriptを下のように書いたのですが、エラーが出てしまいます。
どのように、修正すればエラーが出なくなるのか、また、原因を教えていただけると嬉しいです。

#!/bin/bash

if [ "$(uname)" == 'Darwin' ]; then
  if [ "$( sw_vers -productVersion )" -ge "10.15" ]; then
    echo "Catalina以降"
  else
    echo "Catalina以前"
  fi
  OS='Mac $(sw_vers -productVersion)'
elif [ "$(expr substr $(uname -s) 1 5)" == 'Linux' ]; then
  OS='Linux'
else
  echo "Your platform ($(uname -a)) is not supported."
  exit 1
fi
install.sh: line 4: [: 10.15: integer expression expected
  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

checkベストアンサー

+1

-geなどの算術比較の場合は、両辺は整数を表す文字列である必要があります。.は駄目です。

sw_vers -productVersionは、3つの数字を.で繋いだもののようですね。
100進数として、数に直します。

if [ "$(uname)" == 'Darwin' ]; then
  v=($( sw_vers -productVersion | sed 's/\./ /g') )
  let version=${v[0]}*10000+${v[1]}*100+${v[2]}
  if [ $version -ge 101500 ]; then
    echo "Catalina以降"
  else
    echo "Catalina以前"
  fi

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/12/10 09:47

    回答ありがとうございます。どちらをベストアンサーにするか迷いましたが、回答が早かった、また、Bashで答えていただいたので、ベストアンサーに選ばさせていただきます。

    キャンセル

+1

  1. if [ "$( sw_vers -productVersion )" -ge "10.15" ]; then
    testの比較は整数のみです。小数の比較はできません。

  2. さらに、sw_vers -productVersion小数にもなりません(例えば10.13.6とか)。

なので、根本的に設計し直す必要があります。
ちなみに10.14.9と10.14.10では後者がより新しいパッチレベルです。

rubyのワンライナーだと次のとおり

$ ruby -e "puts Gem::Version.create('10.14.10') < Gem::Version.create('10.14.8')"
>>> false

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/12/10 09:48

    回答ありがとうございます。今回は、RubyのプログラムをBashに埋め込もうと思います。参考になりました。ありがとうございました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.06%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る